 /***************************************************************************\
 * ThyAPI - Thyamad Javascript API - Table Grid Contents Element             *
 * http://www.thyamad.com                                                    *
 *                                                                           *
 * Copyright (C) 2005 - Raphael Derosso Pereira                              *
 * Based on DynAPI v3.0b1                                                    *
 * ------------------------------------------------------------------------- *
 *  This library is free software; you can redistribute it and/or modify it  *
 *  under the terms of the GNU Lesser General Public License as published    *
 *  by the Free Software Foundation; either version 2.1 of the License,      *
 *  or any later version.                                                    *
 *  This library is distributed in the hope that it will be useful, but      *
 *  WITHOUT ANY WARRANTY; without even the implied warranty of               *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                     *
 *  See the GNU Lesser General Public License for more details.              *
 \***************************************************************************/


	/**
	 * Class: thyGridContents
	 *
	 *	This is the Grid Contents class. It is a <thyPanel> that creates a TABLE
	 *	element and overload some of it methods to guarantee that the TABLE will 
	 *	be constructed correctly
	 *
	 * CSS Classes:
	 *
	 *	- .thyGridContents
	 *
	 *	- .<object name>
	 *
	 * See Also:
	 *
	 *	- <thyGrid>
	 *
	 *	- <thyPanel>
	 *
	 */
	function thyGridContents(name)
	{
		this.thyPanel = thyPanel;
		this.thyPanel(name);
	}

	p = dynapi.setPrototype('thyGridContents','thyPanel');

	/**
	 * Method: getOuterHTML
	 *
	 *	Overwritten method that draws TABLE element instead of DIV
	 *
	 */
	p.getOuterHTML = function ()
	{
		var html = [
			'<table id="'+this.id+'"',
			(this.disabled ? 'disabled' : ''),
			(this.readOnly?'readonly':''),
			'cellpadding="0"',
			'cellspacing="0"',
			'border="0"',
			'style="',
			'width:100%;',
			'"><tbody>',
			this.getInnerHTML(),
			//(this.contentRelative ? '</div></div>' : '</div>')
			'</tbody></table>'
		].join('');
		//alert(html);
		return html;
	}

	/**
	 * Method: invokeEvent
	 *
	 *	Overloaded method that calls the invokeEvent of <thyGrid> instead
	 *	of this.
	 *
	 */
	p.invokeEvent = function (eventName, eventObj)
	{
		if (!this.parent || !this.parent.parent) return;

		this.parent.parent.invokeEvent(eventName, eventObj);
	}
